Package org.eclipse.rdf4j.query.algebra.evaluation.impl

## Class TupleFunctionEvaluationStrategy

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.evaluation.impl.StrictEvaluationStrategy
  - - org.eclipse.rdf4j.query.algebra.evaluation.impl.TupleFunctionEvaluationStrategy

- All Implemented Interfaces:
    `EvaluationStrategy`, `FederatedServiceResolver`, `FederatedServiceResolverClient`, `UUIDable`
  Direct Known Subclasses:
    `ExtendedEvaluationStrategy`

      public class TupleFunctionEvaluationStrategy
      extends StrictEvaluationStrategy

  An `EvaluationStrategy` that has support for `TupleFunction`s.

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.rdf4j.query.algebra.evaluation.impl.StrictEvaluationStrategy

      `dataset, serviceResolver, tripleSource`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TupleFunctionEvaluationStrategy​(TripleSource tripleSource, Dataset dataset, FederatedServiceResolver serviceResolver)` |
    `TupleFunctionEvaluationStrategy​(TripleSource tripleSource, Dataset dataset, FederatedServiceResolver serviceResolver, long iterationCacheSyncThreshold)` |
    `TupleFunctionEvaluationStrategy​(TripleSource tripleSource, Dataset dataset, FederatedServiceResolver serviceResolver, long iterationCacheSyncThreshold, EvaluationStatistics evaluationStatistics)` |
    `TupleFunctionEvaluationStrategy​(TripleSource tripleSource, Dataset dataset, FederatedServiceResolver serviceResolver, TupleFunctionRegistry tupleFunctionRegistry)` |
    `TupleFunctionEvaluationStrategy​(TripleSource tripleSource, Dataset dataset, FederatedServiceResolver serviceResolver, TupleFunctionRegistry tupleFuncRegistry, long iterationCacheSyncThreshold, EvaluationStatistics evaluationStatistics)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static CloseableIteration<BindingSet,​QueryEvaluationException>` | `evaluate​(TupleFunction func, List<Var> resultVars, BindingSet bindings, ValueFactory valueFactory, Value... argValues)` |
    `CloseableIteration<BindingSet,​QueryEvaluationException>` | `evaluate​(TupleExpr expr, BindingSet bindings)` | Deprecated, for removal: This API element is subject to removal in a future version.
    `CloseableIteration<BindingSet,​QueryEvaluationException>` | `evaluate​(TupleFunctionCall expr, BindingSet bindings)` | Deprecated, for removal: This API element is subject to removal in a future version.
    `QueryEvaluationStep` | `precompile​(TupleExpr expr, QueryEvaluationContext context)` |
    `protected QueryEvaluationStep` | `prepare​(TupleFunctionCall expr, QueryEvaluationContext context)` |

    - ### Methods inherited from class org.eclipse.rdf4j.query.algebra.evaluation.impl.StrictEvaluationStrategy

      `evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, evaluate, getLimit, getService, getUUID, getVarValue, isReducedOrDistinct, isTrue, isTrue, optimize, precompile, precompile, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, prepare, setFederatedServiceResolver, setOptimizerPipeline, setTrackResultSize, setTrackTime, supplyBinaryValueEvaluation, supplyUnaryValueEvaluation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.evaluation.EvaluationStrategy

      `makeQueue, makeSet`

- - ### Constructor Detail

    - #### TupleFunctionEvaluationStrategy

          public TupleFunctionEvaluationStrategy​(TripleSource tripleSource,
                                                 Dataset dataset,
                                                 FederatedServiceResolver serviceResolver)

    - #### TupleFunctionEvaluationStrategy

          public TupleFunctionEvaluationStrategy​(TripleSource tripleSource,
                                                 Dataset dataset,
                                                 FederatedServiceResolver serviceResolver,
                                                 long iterationCacheSyncThreshold)

    - #### TupleFunctionEvaluationStrategy

          public TupleFunctionEvaluationStrategy​(TripleSource tripleSource,
                                                 Dataset dataset,
                                                 FederatedServiceResolver serviceResolver,
                                                 TupleFunctionRegistry tupleFunctionRegistry)

    - #### TupleFunctionEvaluationStrategy

          public TupleFunctionEvaluationStrategy​(TripleSource tripleSource,
                                                 Dataset dataset,
                                                 FederatedServiceResolver serviceResolver,
                                                 TupleFunctionRegistry tupleFuncRegistry,
                                                 long iterationCacheSyncThreshold,
                                                 EvaluationStatistics evaluationStatistics)

    - #### TupleFunctionEvaluationStrategy

          public TupleFunctionEvaluationStrategy​(TripleSource tripleSource,
                                                 Dataset dataset,
                                                 FederatedServiceResolver serviceResolver,
                                                 long iterationCacheSyncThreshold,
                                                 EvaluationStatistics evaluationStatistics)

  - ### Method Detail

    - #### evaluate

          @Deprecated(forRemoval=true)
          public CloseableIteration<BindingSet,​QueryEvaluationException> evaluate​(TupleExpr expr,
                                                                                        BindingSet bindings)
                                                                                 throws QueryEvaluationException

      Deprecated, for removal: This API element is subject to removal in a future version.
      Description copied from interface: `EvaluationStrategy`
      Evaluates the tuple expression against the supplied triple source with the specified set of variable bindings as input.
      Specified by:
        `evaluate` in interface `EvaluationStrategy`
      Overrides:
        `evaluate` in class `StrictEvaluationStrategy`
      Parameters:
        `expr` - The Tuple Expression to evaluate
        `bindings` - The variables bindings to use for evaluating the expression, if applicable.
      Returns:
        A closeable iterator over the variable binding sets that match the tuple expression.
      Throws:
        `QueryEvaluationException`

    - #### precompile

          public QueryEvaluationStep precompile​(TupleExpr expr,
                                                QueryEvaluationContext context)
                                         throws QueryEvaluationException

      Specified by:
        `precompile` in interface `EvaluationStrategy`
      Overrides:
        `precompile` in class `StrictEvaluationStrategy`
      Throws:
        `QueryEvaluationException`

    - #### evaluate

          @Deprecated(forRemoval=true)
          public CloseableIteration<BindingSet,​QueryEvaluationException> evaluate​(TupleFunctionCall expr,
                                                                                        BindingSet bindings)
                                                                                 throws QueryEvaluationException

      Deprecated, for removal: This API element is subject to removal in a future version.
      Throws:
        `QueryEvaluationException`

    - #### prepare

          protected QueryEvaluationStep prepare​(TupleFunctionCall expr,
                                                QueryEvaluationContext context)
                                         throws QueryEvaluationException

      Throws:
        `QueryEvaluationException`

    - #### evaluate

          public static CloseableIteration<BindingSet,​QueryEvaluationException> evaluate​(TupleFunction func,
                                                                                               List<Var> resultVars,
                                                                                               BindingSet bindings,
                                                                                               ValueFactory valueFactory,
                                                                                               Value... argValues)
                                                                                        throws QueryEvaluationException

      Throws:
        `QueryEvaluationException`